//
//
//	OBJ tokens
//
//										(C) JoOl 1998


#ifndef _TOKENS_OBJ_H_
#define _TOKENS_OBJ_H_


enum
{
	TOKEN_SLASH = LAP_TOKEN_LAST,

	// Vertex data
	TOKEN_V,
	TOKEN_VTEXTURE,				// Vertex texture coordinates
	TOKEN_VNORMAL,				// Vertex normal
	TOKEN_VPARAM,				// Parameter space vertex
	TOKEN_CSTYPE,				// Curve or Surface type
		TOKEN_RAT,				// Indicate rational curves or surfaces
		TOKEN_BMATRIX,			// Curce or surface type
		TOKEN_BEZIER,
		TOKEN_BSPLINE,
		TOKEN_CARDINAL,
		TOKEN_TAYLOR,
	TOKEN_DEGREE,				// degree

	TOKEN_BMATU,				// Basis matrix u
	TOKEN_BMATV,				// Basis matrix v
	TOKEN_STEP,					// Step size

	// Elements
	TOKEN_POINT,
	TOKEN_LINE,
	TOKEN_FACE,
	TOKEN_CURVE,
	TOKEN_CURVE2D,
	TOKEN_SURFACE,

	// Free-form curve/surface body statements
	TOKEN_PARAMU,				// parameter values u
	TOKEN_PARAMV,				// parameter values v
	TOKEN_TRIM,					// outer trimming loop
	TOKEN_HOLE,					// inner trimming loop
	TOKEN_SCURVE,				// special curve
	TOKEN_SPOINT,				// special point
	TOKEN_ENDSTMT,				// end statement

	// Connectivity between free-form surfaces
	TOKEN_CONNECT,

	// Grouping
	TOKEN_GROUPNAME,
	TOKEN_SMOOTHGROUP,
	TOKEN_MERGEGROUP,
	TOKEN_OBJECTNAME,

	// Display/render attributes
	TOKEN_BEVELINTERP,			// Bevel interpolation

	TOKEN_CINTERP,				// Color interpolation
	TOKEN_DINTERP,				// Dissolve interpolation

	TOKEN_LOD,					// Level of detail
	TOKEN_MAPLIB,
	TOKEN_USEMAP,
	TOKEN_USEMATERIAL,
	TOKEN_MATLIB,
	TOKEN_SHADOW,				// Shadow casting
	TOKEN_TRACE,				// Raytracing

	TOKEN_CTECH,				// Curve approximation technique
	TOKEN_STECH,				// Surface approx technique
		TOKEN_CPARM,
		TOKEN_CSPACE,
		TOKEN_CPARMA,
		TOKEN_CPARMB,

	TOKEN_BSP,
	TOKEN_BZP,
	TOKEN_CDC,
	TOKEN_CDP,
	TOKEN_RES
};



#endif	/* _TOKENS_OBJ_H_ */

